Eclipse Remote Application Platform

## org.eclipse.swt.widgets
Class Layout

    java.lang.Object
      org.eclipse.swt.widgets.Layout

Direct Known Subclasses:
  FillLayout, FormLayout, GridLayout, RowLayout, StackLayout

    public abstract class Layout

extends java.lang.Object

A layout controls the position and size of the children of a composite widget. This class is the abstract base class for layouts.

See Also:
  `Composite.setLayout(Layout)`

Constructor Summary
`Layout()`

Method Summary
`protected abstract Point` `computeSize(Composite composite, int wHint, int hHint, boolean flushCache)` Computes and returns the size of the specified composite's client area according to this layout.
`protected boolean` `flushCache(Control control)` Instruct the layout to flush any cached values associated with the control specified in the argument `control`.
`protected abstract void` `layout(Composite composite, boolean flushCache)` Lays out the children of the specified composite according to this layout.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Layout

    public Layout()

Method Detail

### layout

    protected abstract void layout(Composite composite,
                                   boolean flushCache)

  Lays out the children of the specified composite according to this layout.

  This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

  When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is laid out.

  When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

  Parameters:
    `composite` - a composite widget using this layout
    `flushCache` - `true` means flush cached layout values

### flushCache

    protected boolean flushCache(Control control)

  Instruct the layout to flush any cached values associated with the control specified in the argument `control`.

  Parameters:
    `control` - a control managed by this layout
  Returns:
    true if the Layout has flushed all cached information associated with control

### computeSize

    protected abstract Point computeSize(Composite composite,
                                         int wHint,
                                         int hHint,
                                         boolean flushCache)

  Computes and returns the size of the specified composite's client area according to this layout.

  This method computes the size that the client area of the composite must be in order to position all children at their preferred size inside the composite according to the layout algorithm encoded by this layout.

  When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

  Parameters:
    `composite` - a composite widget using this layout
    `wHint` - width (`SWT.DEFAULT` for preferred size)
    `hHint` - height (`SWT.DEFAULT` for preferred size)
    `flushCache` - `true` means flush cached layout values
  Returns:
    a point containing the computed size (width, height)
  See Also:
    `layout(org.eclipse.swt.widgets.Composite, boolean)`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

Eclipse Remote Application Platform

Copyright (c) EclipseSource and others 2002, 2014. All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0